VERSION 5.00
Begin VB.Form frmColor 
   Caption         =   "RGB Color Sampler"
   ClientHeight    =   2535
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4830
   LinkTopic       =   "Form1"
   ScaleHeight     =   2535
   ScaleWidth      =   4830
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtHex 
      Height          =   330
      Index           =   2
      Left            =   4275
      TabIndex        =   15
      Top             =   540
      Width           =   465
   End
   Begin VB.TextBox txtHex 
      Height          =   330
      Index           =   1
      Left            =   3735
      TabIndex        =   14
      Top             =   540
      Width           =   465
   End
   Begin VB.TextBox txtHex 
      Height          =   330
      Index           =   0
      Left            =   3195
      TabIndex        =   13
      Top             =   540
      Width           =   465
   End
   Begin VB.TextBox txtDecimal 
      Height          =   330
      Index           =   2
      Left            =   4275
      TabIndex        =   12
      Top             =   180
      Width           =   465
   End
   Begin VB.TextBox txtDecimal 
      Height          =   330
      Index           =   1
      Left            =   3735
      TabIndex        =   11
      Top             =   180
      Width           =   465
   End
   Begin VB.TextBox txtDecimal 
      Height          =   330
      Index           =   0
      Left            =   3195
      TabIndex        =   10
      Top             =   180
      Width           =   465
   End
   Begin VB.VScrollBar vsRGB 
      Height          =   1455
      Index           =   2
      Left            =   4410
      TabIndex        =   7
      Top             =   945
      Width           =   240
   End
   Begin VB.VScrollBar vsRGB 
      Height          =   1455
      Index           =   1
      Left            =   3870
      TabIndex        =   6
      Top             =   945
      Width           =   240
   End
   Begin VB.VScrollBar vsRGB 
      Height          =   1455
      Index           =   0
      Left            =   3330
      TabIndex        =   5
      Top             =   945
      Width           =   240
   End
   Begin VB.Frame Frame1 
      Caption         =   "Update Which?"
      Height          =   870
      Left            =   90
      TabIndex        =   2
      Top             =   45
      Width           =   1590
      Begin VB.OptionButton optBody 
         Caption         =   "Bo&dy"
         Height          =   240
         Left            =   90
         TabIndex        =   4
         Top             =   540
         Width           =   1410
      End
      Begin VB.OptionButton optHead 
         Caption         =   "&Head"
         Height          =   240
         Left            =   90
         TabIndex        =   3
         Top             =   270
         Value           =   -1  'True
         Width           =   1410
      End
   End
   Begin VB.PictureBox picBody 
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   915
      Left            =   90
      ScaleHeight     =   855
      ScaleWidth      =   1530
      TabIndex        =   1
      Top             =   1485
      Width           =   1590
   End
   Begin VB.PictureBox picHead 
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   465
      Left            =   90
      ScaleHeight     =   405
      ScaleWidth      =   1530
      TabIndex        =   0
      Top             =   1035
      Width           =   1590
   End
   Begin VB.Label Label2 
      Caption         =   "&Hex Value"
      Height          =   240
      Left            =   1845
      TabIndex        =   9
      Top             =   585
      Width           =   1275
   End
   Begin VB.Label Label1 
      Caption         =   "&Decimal Value"
      Height          =   240
      Left            =   1845
      TabIndex        =   8
      Top             =   225
      Width           =   1275
   End
End
Attribute VB_Name = "frmColor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const mclngRedColor     As Long = 0
Private Const mclngGreenColor   As Long = 1
Private Const mclngBlueColor    As Long = 2

Private mbolUpdateColor         As Boolean
Private Sub UpdateColors()

    Dim picToUpdate     As PictureBox

    If mbolUpdateColor = False Then Exit Sub
    
    ' Determine which picture box we should update
    If optHead.Value Then
        Set picToUpdate = picHead
    Else
        Set picToUpdate = picBody
    End If
    
    picToUpdate.BackColor = RGB(txtDecimal(mclngRedColor), txtDecimal(mclngGreenColor), txtDecimal(mclngBlueColor))
    
    Set picToUpdate = Nothing
End Sub

Private Sub Form_Load()
    
    mbolUpdateColor = True
    
    picBody.BorderStyle = vbBSNone
    picHead.BorderStyle = vbBSNone
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Configure the scroll bars
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    With vsRGB(mclngRedColor)
        .Max = 255
        .Min = 0
        .LargeChange = 10
        .SmallChange = 1
    End With
    
    With vsRGB(mclngGreenColor)
        .Max = 255
        .Min = 0
        .LargeChange = 10
        .SmallChange = 1
    End With
    
    With vsRGB(mclngBlueColor)
        .Max = 255
        .Min = 0
        .LargeChange = 10
        .SmallChange = 1
    End With
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Configure the decimal books
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    With txtDecimal(mclngRedColor)
        .ToolTipText = "Enter the color of the red portion"
        .MaxLength = 3
        .Text = 0
    End With
    
    With txtDecimal(mclngGreenColor)
        .ToolTipText = "Enter the color of the green portion"
        .MaxLength = 3
        .Text = 0
    End With
    
    With txtDecimal(mclngBlueColor)
        .ToolTipText = "Enter the color of the blue portion"
        .MaxLength = 3
        .Text = 0
    End With
    
    With txtHex(mclngRedColor)
        .ToolTipText = "Enter the color of the red portion"
        .MaxLength = 2
        .Text = 0
    End With
    
    With txtHex(mclngGreenColor)
        .ToolTipText = "Enter the color of the green portion"
        .MaxLength = 2
        .Text = 0
    End With
    
    With txtHex(mclngBlueColor)
        .ToolTipText = "Enter the color of the blue portion"
        .MaxLength = 2
        .Text = 0
    End With
End Sub


Private Sub Form_Unload(Cancel As Integer)
    Set frmColor = Nothing
End Sub


Private Sub optBody_Click()
    mbolUpdateColor = False
    txtDecimal(mclngRedColor).Text = picBody.BackColor And &HFF&
    txtDecimal(mclngGreenColor).Text = (((picBody.BackColor And &HFF00&) \ &H100&) And &HFF)
    txtDecimal(mclngBlueColor).Text = (((picBody.BackColor And &HFF0000) \ &H10000) And &HFF)
    txtHex(mclngRedColor).Text = Hex$(txtDecimal(mclngRedColor))
    txtHex(mclngGreenColor).Text = Hex$(txtDecimal(mclngGreenColor))
    txtHex(mclngBlueColor).Text = Hex$(txtDecimal(mclngBlueColor))
    mbolUpdateColor = True
End Sub

Private Sub optHead_Click()
    mbolUpdateColor = False
    txtDecimal(mclngRedColor).Text = picHead.BackColor And &HFF&
    txtDecimal(mclngGreenColor).Text = (((picHead.BackColor And &HFF00&) \ &H100&) And &HFF)
    txtDecimal(mclngBlueColor).Text = (((picHead.BackColor And &HFF0000) \ &H10000) And &HFF)
    txtHex(mclngRedColor).Text = Hex$(txtDecimal(mclngRedColor))
    txtHex(mclngGreenColor).Text = Hex$(txtDecimal(mclngGreenColor))
    txtHex(mclngBlueColor).Text = Hex$(txtDecimal(mclngBlueColor))
    mbolUpdateColor = True
End Sub


Private Sub txtDecimal_GotFocus(Index As Integer)
    txtDecimal(Index).SelStart = 0
    txtDecimal(Index).SelLength = Len(txtDecimal(Index).Text)
End Sub

Private Sub txtDecimal_LostFocus(Index As Integer)
    ' Check for a value greater than 255
    If Val(txtDecimal(Index).Text) > 255 Then
        txtDecimal(Index).Text = 255
    End If
    
    ' Check for a value less than 0
    If Val(txtDecimal(Index).Text) < 0 Then
        txtDecimal(Index).Text = 0
    End If
    
    vsRGB(Index).Value = Val(txtDecimal(Index).Text)
End Sub


Private Sub txtHex_GotFocus(Index As Integer)
    txtHex(Index).SelStart = 0
    txtHex(Index).SelLength = Len(txtHex(Index).Text)
End Sub

Private Sub txtHex_LostFocus(Index As Integer)
    txtDecimal(Index).Text = Trim$(Str(Val("&h" & txtHex(Index).Text)))
    txtHex(Index).Text = UCase$(txtHex(Index).Text)
    
    vsRGB(Index).Value = Val(txtDecimal(Index).Text)
End Sub


Private Sub vsRGB_Change(Index As Integer)
    txtDecimal(Index).Text = Trim(Str$(vsRGB(Index).Value))
    txtHex(Index).Text = Hex$(Trim$(Str$(vsRGB(Index).Value)))
    UpdateColors
End Sub

